
	function isNumericType(type) {
		return ((type == 'int2') || (type == 'int4') || (type == 'int8') || (type == 'float4') || (type == 'float8'));
	}

	function trim(str)
	{
		return str.replace(/^\s*|\s*$/g, '');
	}

	var ALIGN_LEFT = 1;
	var ALIGN_RIGHT = 2;
	var ALIGN_CENTER = 3;

	function align(str, width, mode) {
		var ret = null;
		if (str.length > width)
			ret = str.substr(0, width);
		else if (str.length < width) {
			ret = str;
			if (mode == ALIGN_CENTER) {
				var alt = false;
				while (ret.length < width) {
					if (alt) {
						ret = ret + ' ';
						alt = false;
					}
					else {
						ret = ' ' + ret;
						alt = true;
					}
				}
			}
			else if (mode == ALIGN_LEFT) {
				while (ret.length < width)
					ret = ret + ' ';
			}
			else if (mode == ALIGN_RIGHT) {
				while (ret.length < width)
					ret = ' ' + ret;
			}
		}
		else
			ret = str;
		return ret;
	}

	function repeat(str, num) {
		var ret = '';
		for (var i = 0; i < num; i++)
			ret += str;
		return ret;
	}

	function generarArbolDocumento(obj) {
		var str = '';
		if (obj.childNodes.length != 0) {
			str = '<ol>';
			for (var i = 0; i < obj.childNodes.length; i++) {
				var hijo = obj.childNodes[i];
				// if (hijo.tagName != undefined) {
				if (hijo.nodeType == 1) {
					var strAtributos = '';
					for (var j = 0; j < hijo.attributes.length; j++)
						strAtributos += ' ' + hijo.attributes[j].nodeName.toLowerCase() + '="' + hijo.attributes[j].nodeValue + '"';
					str += '<li>' + hijo.tagName + strAtributos + '</li>';
					str += generarArbolDocumento(hijo);
				}
				else if (hijo.nodeType == 3) {
					if (hijo.nodeValue) {
						var strAux = trim(hijo.nodeValue);
						if (strAux != '')
							str += '<li> (' + hijo.nodeValue + ')</li>';
					}
				}
			}
			str += '</ol>';
		}
		return str;
	}

	function Row_get(column) {
		return this.fields[column];
	}

	function ResultSet_toHtmlString() {
		var ret = this.rows.length + ' row(s)<br>\n';
		for (var i = 0; i < this.rows.length; i++) {
			for (var j = 0; j < this.columns.length; j++) {
				var v = this.rows[i].get(this.columns[j].name);
				ret += this.columns[j].name + ':' + this.columns[j].type + '="' + v + '" ';
			}
			ret += '<br>\n';
		}
		return ret;
	}

	function ResultSet_toPreString() {
		var ret = this.rows.length + ' row(s)\n';
		// Primero pintamos las cabeceras
		var cabecera = '|';
		var separador = '+';
		for (var i = 0; i < this.columns.length; i++) {
			var v = align(this.columns[i].name, this.columns[i].width, ALIGN_CENTER);
			cabecera += v + '|';
			separador += repeat('-', this.columns[i].width) + '+';
		}
		ret += cabecera + '\n' + separador + '\n';
		var valores = '';
		for (var i = 0; i < this.rows.length; i++) {
			valores += '|';
			for (var j = 0; j < this.columns.length; j++) {
				var v = this.rows[i].get(this.columns[j].name);
				if (isNumericType(this.columns[j].type))
					valores += align(v, this.columns[j].width, ALIGN_RIGHT);
				else
					valores += align(v, this.columns[j].width, ALIGN_LEFT);
				valores += '|';
			}
			valores += '\n';
		}
		ret += valores;
		return ret;
	}

	function JSSQLConnection_replaceSpecials(str) {
		var pat = new Array('.lt.', '.gt.',
		                    '.Aacute.', '.Eacute.', '.Iacute.', '.Oacute.', '.Uacute.', '.Uuml.', '.Ntilde.',
		                    '.aacute.', '.eacute.', '.iacute.', '.oacute.', '.uacute.', '.uuml.', '.ntilde.',
		                    '.iquest.', '.iexcl.', '.euro.', '.ordf.', '.ordm.', '.dot.');
		var rep = new Array('<', '>',
		                    '', '', '', '', '', '', '',
		                    '', '', '', '', '', '', '',
		                    '', '', '', '', '', '.');
		if (this.escapeSpecials) {
			rep[0] = '&lt;';
			rep[1] = '&gt;';
		}
		var n = pat.length;
		for (var i = 0; i < n; i++) {
			str = str.replace(pat[i], rep[i]);
		}
		return str;
	}

	function JSSQLConnection_createResult() {
		var ret = new Object();
		ret.affectedRows = -1;
		ret.toHtmlString = ResultSet_toHtmlString;
		ret.toPreString = ResultSet_toPreString;
		ret.rows = new Array();
		// Buscamos los posibles errores
		var errors = this.petition.responseXML.getElementsByTagName('error');
		if (errors.length > 0) {
			this.errorString = errors[0].getAttribute('text');
			return null;
		}
		var fields = new Array();
		var columns = this.petition.responseXML.getElementsByTagName('column');
		var numColumns = columns.length;
		// alert('numColumns=' + numColumns);
		if (numColumns > 0) {
			// Las columnas
			for (var col = 0; col < numColumns; col++) {
				var column = columns[col];
				if (column.nodeType == 1) {
					var field = new Object();
					field.name = column.getAttribute('name');
					field.type = column.getAttribute('type');
					field.width = field.name.length;
					fields[fields.length] = field;
				}
			}
			ret.columns = fields;
			// Las filas
			var rows = this.petition.responseXML.getElementsByTagName('row');
			// alert('numRows=' + rows.length);
			for (var r = 0; r < rows.length; r++) {
				var currRow = rows[r];
				var rowObj = new Object();
				rowObj.get = Row_get;
				rowObj.fields = new Array();
				ret.rows[ret.rows.length] = rowObj;
				for (var at = 0; at < currRow.attributes.length; at++) {
					// var value = currRow.attributes[at].nodeValue;
					var value = this.replaceSpecials(currRow.attributes[at].nodeValue);
					rowObj.fields[fields[at].name] = value;
					if (value.length > fields[at].width)
						fields[at].width = value.length;
				}
			}
		}
		else {
			var affectedRows = this.petition.responseXML.getElementsByTagName('affectedrows');
			if (affectedRows.length > 0)
				ret.affectedRows = parseInt(affectedRows[0].getAttribute('amount'));
		}
		return ret;
	}

	function JSSQLConnection_query(sql) {
		if (window.XMLHttpRequest) {
			// W3C
			this.petition = new XMLHttpRequest();
		}
		else if (window.ActiveXObject) {
			// IE
			this.petition = new ActiveXObject('Microsoft.XMLHTTP');
		}
		var result = null;
		if (this.petition) {
			// Al indicarle false en el ltumi parmetro hacemos la conexin bloqueante y justo despus del send tendremos el resultado
			this.petition.open('POST', this.xmlUrl, false);
			this.petition.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			var cadenaPost = 'connection=' + this.connectionString + '&query=' + sql;
			// alert(cadenaPost);
			this.petition.send(cadenaPost);
			// Comprobamos el estado de la consulta
			if (this.petition.readyState == 4) {
				if (this.petition.status == 200) {
					if (this.petition.responseXML != null) {
						if (this.idDebug != null)
							document.getElementById(this.idDebug).innerHTML = generarArbolDocumento(this.petition.responseXML);
						this.errorString = null;
						result = this.createResult();
					}
					else {
						this.errorString = 'Malformed XML. Check the Content-Type response header.';
						// alert(this.errorString);
					}
				}
				else {
					this.errorString = this.petition.statusText;
					// alert(this.errorString);
				}
			}
			else {
				this.errorString = this.petition.statusText;
				// alert(this.errorString);
			}
		}
		return result;
	}

	function JSSQLConnection(connectionString) {
		this.connectionString = connectionString;
		this.petition = null;
		this.xmlUrl = 'jssql.xml.php';
		this.errorString = null;
		this.affectedRows = -1;
		this.query = JSSQLConnection_query;
		this.createResult = JSSQLConnection_createResult;
		this.replaceSpecials = JSSQLConnection_replaceSpecials;
		this.idDebug = null;
		this.escapeSpecials = false;
	}

